import 'platform:/resource/org.gemoc.sigpml.model/model/sigpml.ecore'
--import 'http://org.gemoc.sigpml.sigpml.model/1.0'


ECLimport "platform:/resource/org.gemoc.sigpml.moc.lib/MoCLib/AgentApplicationMoC.mocc"
ECLimport "platform:/resource/org.gemoc.sigpml.moc.lib/MoCLib/SDF.ccslLib"
ECLimport "platform:/plugin/fr.inria.aoste.timesquare.ccslkernel.model/ccsllibrary/kernel.ccslLib" 
ECLimport "platform:/plugin/fr.inria.aoste.timesquare.ccslkernel.model/ccsllibrary/CCSL.ccslLib" 

package sigpml
	
	context Place
		--def:  diff : Integer = (self.size - self.itsOutputPort.rate)
		def : write :Event = self
		def : read :Event = self
				
	context Agent 
		def : start : Event = self
		def : stop : Event = self
		def : isExecuting : Event = self
		
	context HWComputationalResource
		def : isExecuting : Event= self
--		def : idle: Event= self
		
	context Agent	
		inv AgentComputing:
		 let execTime : Integer = self.cycles in
			Relation AgentExecution(self.start, self.stop, self.isExecuting, execTime)
	
	context Place
	 	inv TokenConstraint:
	 		let popRate : Integer = self.itsInputPort.rate in
	 		let pushRate : Integer = self.itsOutputPort.rate in
	 		let maxSize : Integer = self.size in
			let initialSize : Integer = self.delay in
			Relation PlaceConstraint(
				self.write,
				self.read,
				initialSize,
				maxSize,
				popRate, 
				pushRate
				)
		 
		inv stopCausesWrite:
		Relation Coincides(self.itsOutputPort.owner.stop, self.write)
		
		inv readCausesStart:
		Relation Coincides(self.read, self.itsInputPort.owner.start)
	
	context HWComputationalResource
	
--	inv IsExecutingXorIdle:
--		Relation Exclusion(self.isExecuting,self.idle)
	
	inv oneAgentAtATime:
		Relation Exclusion(self.allocatedAgents.oclAsType(Agent).isExecuting)
	
	inv ExecutesItsAllocatedAgents:
		let allAgentsExecutions : Event = Expression Union(self.allocatedAgents.oclAsType(Agent).isExecuting) in
		Relation Coincides(self.isExecuting, allAgentsExecutions)
		
	inv NonPreemptiveExecution: 
		(self.isUnderPreemptiveManagement) implies
		let allAgentStarts : Event = Expression Union(self.allocatedAgents.oclAsType(Agent).start) in
		let allAgentStops : Event = Expression Union(self.allocatedAgents.oclAsType(Agent).stop) in
		Relation Alternates(allAgentStarts, allAgentStops)

endpackage